//--------------------------------
// T107BL driver
// Author: Sadegh Mohammadi
// Date: 1391/05/28
//--------------------------------

#include "stm32f10x.h"
#include "I2C.h"
#include "USART_init_.h"
#include "lcd4bit.h"

unsigned char v_ChipID,v_RevisionID,v_DateCodeID;
 
//----------------------------------------------------
void Page_SEL(unsigned char _page_sel)
{
	I2C_write_BYTE( 0xFF, _page_sel);
}

//-----------------------------------------------
unsigned char Read_T107BL_ChipID(void)
{
	Page_SEL(0x00);  //select page 0
	
	//I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be T107BL
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0x50, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be Chip ID
	I2C_SendData(I2C2,0xF4);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be T107BL
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0x51, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	v_ChipID = I2C_ReceiveData(I2C2);  //reading ChipID	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
		
	return v_ChipID;
}
//-----------------------------------------------
unsigned char Read_T107BL_RevisionID(void)
{
	Page_SEL(0x00);  //select page 0
	//I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be T107BL
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0x50, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be Revision ID
	I2C_SendData(I2C2,0xF5);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be T107BL
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0x51, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	v_RevisionID = I2C_ReceiveData(I2C2);  //reading Revision ID	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
		
	return v_RevisionID;
}
//-----------------------------------------------
unsigned char Read_T107BL_DateCodeID(void)
{
	Page_SEL(0x00);  //select page 0
	//I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be T107BL
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0x50, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be Date Code ID
	I2C_SendData(I2C2,0xF6);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be T107BL
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0x51, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	v_DateCodeID = I2C_ReceiveData(I2C2);  //reading Date Code ID	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
		
	return v_DateCodeID;
}
//------------------------------------------------------------
/*void Setting_PWM_1(void)
{
	I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be T107BL
	// Transmit the slave address and enable writing operation 
  I2C_Send7bitAddress(I2C2, 0x50, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale farmane registere marbot be PWM1
	I2C_SendData(I2C2,0xE8);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	//I2C_AcknowledgeConfig(I2C2,DISABLE);
		
	I2C_SendData(I2C2,0xF7); // sending data for writting
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}	
		
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
}
//--------------------------------------------------------------
void Setting_PWM_1_parm(void)
{
	I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be T107BL
	// Transmit the slave address and enable writing operation 
  I2C_Send7bitAddress(I2C2, 0x50, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale farmane registere marbot be PWM1
	I2C_SendData(I2C2,0xE9);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	//I2C_AcknowledgeConfig(I2C2,DISABLE);
	
	I2C_SendData(I2C2,0xFF); // sending data for writting
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
}*/
//---------------------------------------------------------
void Setting_PWM2_(void)
{
	I2C_write_BYTE( 0x64, 0x00);
	I2C_write_BYTE( 0x68, 0x16);
	I2C_write_BYTE( 0x69, 0x0D);
	I2C_write_BYTE( 0x6A, 0x30);
	I2C_write_BYTE( 0x60, 0x02);
	I2C_write_BYTE( 0x7F, 0x47);
	I2C_write_BYTE( 0xE3, 0x10);
	I2C_write_BYTE( 0x62, 0xC0);
}
//----------------------------------------------------
void Setting_PWM1_(void)
{
	Page_SEL(0x00);   //select page 0
	
	// setting frequency PWM1~3.295KHz ||| PWM1_freq=(XCLK)/( (2^N)*256) = (27MHz)/( (2^5)*256)~3.295KHz
	I2C_write_BYTE( 0xE8, 0x35);   
	I2C_write_BYTE( 0xE9, 0x1F);
	
	Page_SEL(0x00);   //select page 0
}
//----------------------------------------------------
void Setting_GPIOA(void)
{
	Page_SEL(0x01);   //select page 1
	
	I2C_write_BYTE( 0x50, 0x0F);
	I2C_write_BYTE( 0x5C, 0xFF);
	I2C_write_BYTE( 0x5F, 0x0F);
	
	//I2C_write_BYTE( 0x51, 0x01);
	
	Page_SEL(0x00);   //select page 0
}
//----------------------------------------------------
void Setting_PLL(void)
{
	I2C_write_BYTE( 0xC8, 0x15);
	I2C_write_BYTE( 0xC9, 0x02);
	I2C_write_BYTE( 0xCA, 0x03);
}
//----------------------------------------------------
void PWR_Man_CTRL(void)
{
	Page_SEL(0x00);   //select page 0
	I2C_write_BYTE( 0xE0, 0x80);
}
//----------------------------------------------------
void Setbit_GPOA(unsigned char _bit_GPOA)
{
	Page_SEL(0x01);   //select page 1
	I2C_write_BYTE( 0x51, _bit_GPOA);
	Page_SEL(0x00);   //select page 0
}
