
#ifndef __lcd4bit_H
#define __lcd4bit_H

 // Define LCD-16x2 PinIO Interface Mask Bit 
  #define  LCD_EN_PIN		           GPIO_Pin_7	
  #define  LCD_EN_PORT		           GPIOA
  #define  RCC_APB2Periph_GPIO_EN      RCC_APB2Periph_GPIOA

  #define  LCD_RW_PIN		           GPIO_Pin_6		
  #define  LCD_RW_PORT	               GPIOA
  #define  RCC_APB2Periph_GPIO_RW      RCC_APB2Periph_GPIOA

  #define  LCD_RS_PIN 		       	   GPIO_Pin_5		
  #define  LCD_RS_PORT		           GPIOA
  #define  RCC_APB2Periph_GPIO_RS      RCC_APB2Periph_GPIOA

  #define  LCD_D4_PIN 		       	   GPIO_Pin_9		
  #define  LCD_D5_PIN 		       	   GPIO_Pin_10		
  #define  LCD_D6_PIN 		       	   GPIO_Pin_11		
  #define  LCD_D7_PIN 		       	   GPIO_Pin_12		
  #define  LCD_DATA_PORT	           GPIOE
  #define  RCC_APB2Periph_GPIO_DATA    RCC_APB2Periph_GPIOE

  #define  LCD_EN_HI()    	           GPIO_WriteBit(LCD_EN_PORT,LCD_EN_PIN,Bit_SET)
  #define  LCD_EN_LO()		           GPIO_WriteBit(LCD_EN_PORT,LCD_EN_PIN,Bit_RESET)

  #define  LCD_RW_HI()    	           GPIO_WriteBit(LCD_RW_PORT,LCD_RW_PIN,Bit_SET)  
  #define  LCD_RW_LO() 		           GPIO_WriteBit(LCD_RW_PORT,LCD_RW_PIN,Bit_RESET)

  #define  LCD_RS_HI() 	               GPIO_WriteBit(LCD_RS_PORT,LCD_RS_PIN,Bit_SET)
  #define  LCD_RS_LO() 	               GPIO_WriteBit(LCD_RS_PORT,LCD_RS_PIN,Bit_RESET)

  #define  LCD_D4_HI() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D4_PIN,Bit_SET)
  #define  LCD_D4_LO() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D4_PIN,Bit_RESET)

  #define  LCD_D5_HI() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D5_PIN,Bit_SET)
  #define  LCD_D5_LO() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D5_PIN,Bit_RESET)

  #define  LCD_D6_HI() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D6_PIN,Bit_SET)
  #define  LCD_D6_LO() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D6_PIN,Bit_RESET)

  #define  LCD_D7_HI() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D7_PIN,Bit_SET)
  #define  LCD_D7_LO() 	               GPIO_WriteBit(LCD_DATA_PORT,LCD_D7_PIN,Bit_RESET)

  #define  lcd_clear()                 lcd_write_cmd(0x01)	// Clear Display
  #define  lcd_cursor_home()           lcd_write_cmd(0x02)	// Set Cursor = 0
  #define  lcd_display_on()            lcd_write_cmd(0x0E)	// LCD Display Enable
  #define  lcd_display_off()           lcd_write_cmd(0x08)	// LCD Display Disable
  #define  lcd_cursor_blink()          lcd_write_cmd(0x0F)	// Set Cursor = Blink
  #define  lcd_cursor_on()             lcd_write_cmd(0x0E)	// Enable LCD Cursor
  #define  lcd_cursor_off()            lcd_write_cmd(0x0C)	// Disable LCD Cursor
  #define  lcd_cursor_left()           lcd_write_cmd(0x10)	// Shift Left Cursor
  #define  lcd_cursor_right()          lcd_write_cmd(0x14)	// Shift Right Cursor
  #define  lcd_display_sleft()         lcd_write_cmd(0x18)	// Shift Left Display
  #define  lcd_display_sright()        lcd_write_cmd(0x1C)	// Shift Right Display
  
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void lcd_out_data4(unsigned char val);
void lcd_write_byte(unsigned char val);
void lcd_write_cmd(unsigned char val);
void lcd_putchar(unsigned char c);
void lcd_init(void);
void set_cursor(unsigned char column, unsigned char line);
void lcd_putsf(char* str);
void lcd_puts(int num);
char busy_lcd(void);
void enable_lcd(void);
void lcd_bargraph (int value, int size);
void lcd_bargraphXY (int pos_x, int pos_y, int value);

#endif /* __lcd4bit_H */
